/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 23.11.2009
Author  : 
Company : 
Comments: 


Chip type           : ATmega48P
Clock frequency     : 8,000000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 128
*****************************************************/

#include <mega48p.h>
#include "main.h"
#include "delay.h"
char Buffer[256];
unsigned char pos_read,pos_write;
// Timer 1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
TCNT1H=0x0;
OCR1AL=Buffer[pos_read];
pos_read++;
}

// Timer 1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
{
// Place your code here

}



void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=Out Func0=In 
// State7=T State6=T State5=0 State4=T State3=0 State2=0 State1=0 State0=T 
PORTB=0x00;
DDRB=0x2F;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x00;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 8000,000 kHz
// Mode: Fast PWM top=00FFh
// OC1A output: Non-Inv.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: On
// Compare B Match Interrupt: Off
TCCR1A=0x81;
TCCR1B=0x09;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2A output: Disconnected
// OC2B output: Disconnected
ASSR=0x00;
TCCR2A=0x00;
TCCR2B=0x00;
TCNT2=0x00;
OCR2A=0x00;
OCR2B=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// Interrupt on any change on pins PCINT0-7: Off
// Interrupt on any change on pins PCINT8-14: Off
// Interrupt on any change on pins PCINT16-23: Off
EICRA=0x00;
EIMSK=0x00;
PCICR=0x00;

// Timer/Counter 0 Interrupt(s) initialization
TIMSK0=0x00;
// Timer/Counter 1 Interrupt(s) initialization
TIMSK1=0x03;
// Timer/Counter 2 Interrupt(s) initialization
TIMSK2=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
ADCSRB=0x00;

// SPI initialization
// SPI Type: Master
// SPI Clock Rate: 500,000 kHz
// SPI Clock Phase: Cycle Half
// SPI Clock Polarity: Low
// SPI Data Order: MSB First
SPCR=0x51;
SPSR=0x00;

// Global enable interrupts
#asm("sei")

do{
delay_ms(10);
}while (mmc_init() != 0);
t.all=offst;
mmc_read_potok (t.all,nsek); 


while (1)
      {
      // Place your code here
#asm("wdr");
      };
}
unsigned char mmc_write_command (unsigned char *cmd)
{
	unsigned char tmp = 0xff;
	unsigned char a;
	unsigned int Timeout = 0; 

	mmc_dis();
	mmc_write_byte(0xFF);
	mmc_en();
	for ( a = 0;a<0x06;a++) //
		{
		mmc_write_byte(cmd[a]);
		}
  
	while (tmp == 0xff)	
		{
		tmp = mmc_read_byte();//     
		if (Timeout++ > 500) //    
			{
			break; //
			}
		}
	return(tmp); // 
}
//-------------------------------------------------------------------------
  unsigned char mmc_read_byte()
   {
  SPDR = 0x00; 
 while(!(SPSR & (1<<SPIF))){ };
 return SPDR;
 }
//--------------------------------------------------------
//-------------------------------------------------
unsigned char mmc_init (void)
{
unsigned char b;
unsigned int Timeout = 0;
mmc_dis();
	
	for ( b = 0;b<0x0f;b++) //
		{
		mmc_write_byte(0xff);
		}
//--------------------------------------------------	
	while(mmc_write_command (CMD) !=1)//  040 -       01
	{
		if (Timeout++ > 200)
			{
			mmc_dis();
			return(1); 
			}
	}
	//----------------------------------------------

	Timeout = 0;
	CMD[0] = 0x41;//Commando 1// 041 -     00 
	CMD[5] = 0xFF;
	while( mmc_write_command (CMD) !=0)
	{
		if (Timeout++ > 400)
			{
	                mmc_dis();
			return(2); 
			}
	}
	mmc_dis();
	return(0);
}
//---------------------------------------------------------------------
 //---------------------------------------------------------------------
void mmc_read_potok (unsigned long addr,unsigned int sektor)
{

unsigned int i;
unsigned int sek_read=0;
pos_read=0;
pos_write=0;
t.all=addr;
CMD[0]=0x52; //     18 
CMD[1]=t.st.AdrHhi;  // 040 + 012   
CMD[2]=t.st.AdrHlo;
CMD[3]=t.st.AdrLhi;
CMD[4]=t.st.AdrLlo;
CMD[5]=0xFF;
mmc_write_command (CMD); //   


do{
while (mmc_read_byte() != 0xfe){};//   
	for ( i=0;i<512;i++)
		{
        pos_write++;
        while(!(pos_read ^ pos_write));
        Buffer[pos_write]=	mmc_read_byte();
		}
	mmc_read_byte();//CRC 
	mmc_read_byte();//CRC 
			sek_read++;
}while(sek_read != sektor);

//   
CMD[0]=0x4C; //    12 
CMD[1]=0;  // 040 + 00   
CMD[2]=0;
CMD[3]=0;
CMD[4]=0;
CMD[5]=0xFF;
mmc_write_command (CMD); //   
	mmc_dis();
}	
//-----------------------------------------------
void mmc_write_byte(unsigned char X) 
{   
 SPDR=X;
   while (!(SPSR &(1<< SPIF)));
}
//---------------------------------------------
